#procedure ColorSimplify
id SUNTc(?a, [i]?, [j]?) = SUNT(reverse_(?a), [j], [i]);

* introduce dummy indices for the color traces
repeat;
  once SUNT(?a, 0, 0) = SUNT(?a, DUMMY, DUMMY);
  sum DUMMY;
endrepeat;

* take apart SUNTs with more than one T^a_{ij}
repeat;
  once SUNT(?a, [a]?, [b]?, [i]?, [j]?) =
    SUNT(?a, [a], [i], DUMMY) * SUNT([b], DUMMY, [j]);
  sum DUMMY;
endrepeat;

* apply the Fierz identity
* T^a_{ij} T^a_{kl} =
*   1/2 (delta_{il} delta_{jk} - 1/N delta_{ij} delta_{kl})

id SUNT([a]?, [i]?, [j]?) * SUNT([a]?, [k]?, [l]?) =
  1/2 * SUNT([i], [l]) * SUNT([j], [k]) -
  1/2/(`SUNN') * SUNT([i], [j]) * SUNT([k], [l]);

* clean up all remaining deltas

* T^a_{ij} is traceless
id SUNT([a]?, [i]?, [i]?) = 0;

repeat id SUNT([i]?, [j]?) * SUNT([j]?, [k]?) = SUNT([i], [k]);

id SUNT([i]?, [j]?)^2 = `SUNN';
id SUNT([i]?, [i]?) = `SUNN';
#endprocedure

**********************************************************

#define SUNN "3"

Indices [a], [b], [i], [j], [k], [l], [x], [y], DUMMY;
CFunctions SUNT, SUNTc, TMP;

Indices g, c1, c2, c3, c4;
Indices Glu1, Glu2, Col1, Col2;


* now try it:

Local col1 = SUNT(g, c1, c2)*SUNT(g, c3, c4);

#define t1 "Glu1, Glu2, Col2, Col1"
#define t2 "Glu2, Glu1, Col2, Col1"

Local col2a = SUNT(`t1')*SUNTc(`t1');
Local col2b = SUNT(`t1')*SUNTc(`t2');
Local col2c = SUNT(`t2')*SUNTc(`t1');
Local col2d = SUNT(`t2')*SUNTc(`t2');

#call ColorSimplify

print +s;

.end

